#include <cstdio>
#include<coroutine>
#include <ios>
#include <iostream>
#include <source_location>
#include <stdexcept>
#include <type_traits>

template<class T>
struct Promise;

template<class T>
struct coroutine: std::coroutine_handle<Promise<T>>{
    using promise_type = ::Promise<T>;
};

template<class T=void>
struct Promise{
    auto initial_suspend(){
        std::cout<<__FUNCTION__<<'\n';
        return std::suspend_always{};
    }
    auto final_suspend()noexcept{
        std::cout<<__FUNCTION__<<'\n';
        return std::suspend_always{};
    }
    void unhandled_exception(){
        std::cout<<__FUNCTION__<<'\n';
        throw std::runtime_error("unhandled exeception\n");
    }
    void return_value(const std::decay_t<T> &t){
        std::cout<<__FUNCTION__<<' '<<t<<'\n';
    }
    coroutine<T> get_return_object(){
        std::cout<<__FUNCTION__<<'\n';
        return {coroutine<T>::from_promise(*this)};
    }
    auto yield_value(const std::decay_t<T> &t){
        std::cout<<__FUNCTION__<<' '<<t<<'\n';
        return std::suspend_always{};
    }
    
    coroutine<T> h;
};

coroutine<int> test(){
    std::cout<<"testing\n";
    co_yield 1;
    co_yield 2;
    co_return 0;
}

int main(){
    std::cout<<__FUNCTION__<<'\n';
    auto handle = test();
    while (!handle.done()) {
        std::cout<<__FUNCTION__<<'\n';
        handle.resume();
    }
}